

/* ----- SEARCH ROUTINES FOR DATABASE USED ON DEPTS ----- */

#include <stdio.h>
#include <ctype.h>
#include "/usr/unify/include/fdesc.h"
#include "/usr/unify/include/dbtypes.h"
#include "/usr/unify/include/btincl.h"
#include "file.h"
#include "types.h"

extern RECPTR new_rec(), merge(), find();
extern INFOPTR new_info();
extern int in_btree(), matchflds();
extern char *make_name();
extern pr_rec();

RECPTR search_dept(), dept_find();
STUFFPTR get_dinfo(), new_stuff();
char *malloc();

static int counter = 1;

/* ----- find_depts: given btptrs and packet, return dept nums ----- */
RECPTR find_depts (ptrs, wild, packet)
	char **ptrs;
	int *wild;
	PACKET packet;
	{
	RECPTR temp, depts;
	int i=0, rnum, fnum;
	int limit=1;			/* bug in open btree with more than 1
					 * look up of dtnum
					 */
	depts = (RECPTR)0;

	while ((rnum=packet[i][0]) > 0 && (fnum=packet[i][1]) > 0)
		{
		int j=0;
		char t[32];
		char **btptrs;

		if ((btptrs = (char **) malloc(3*sizeof(char *))) == 0)
			printf("malloc contaminated memory\n");

		while (j<limit && ptrs[j] != (char *)0)
			{
			btptrs[0] = ptrs[j];
			btptrs[1] = (char *)0;
again:
			temp = search_dept(btptrs,wild[j],rnum,fnum);
						/* insert a '0' onto the dtnum
						 * DTNUM_LEN==length of dtnums in DB.
						 */
			if (temp->num==0 && (strlen(btptrs[0])<DTNUM_LEN || 
				btptrs[0][0]>'0' && btptrs[0][0]<='9'))
				{
				sprintf(t,"0%s",btptrs[0]);
				btptrs[0] = t;
				goto again;
				}
				
			if (depts==(RECPTR)0 || depts->num==0)
				depts = temp;
			else	depts = merge(depts, temp);

			j++;
			}
		i++;
		}
	return(depts);
	}


/* ----- dept_find:  look for each dept in each possible search ----- */
RECPTR dept_find(depts, packet)
	RECPTR depts;
	PACKET packet;
	{
	RECPTR value, temp;
	STUFFPTR deptr, tack_on;
	char *btptrs[2];
	int wild[2];

	if (depts == (RECPTR)0 || depts->head == (STUFFPTR)0)
		{
		return ((RECPTR)0);
		}
	wild[0] = 0; wild[1] = 0;
	deptr = depts->head; value = (RECPTR)0;

	while (deptr != (STUFFPTR)0)
		{
		btptrs[0] = (char *)(deptr->info);
		btptrs[1] = (char *)0;

		tack_on = get_dinfo(btptrs);
		temp = find(btptrs,wild,packet);

		if (temp->num > 0)
			{
			tack_on->_next = temp->head;
			temp->head = tack_on;
			(temp->num)++;
			}
		else	{
			temp->head = tack_on;
			temp->tail = temp->head;
			(temp->num)++;
			}
		if (value==(RECPTR)0 || value->head==(STUFFPTR)0)
			{
			value = temp;
			}
		else	{
			value->num = value->num + temp->num;
			value->tail->_next = temp->head;
			value->tail = temp->tail;
			}
		deptr = deptr->_next;
		}
	return (value);
	}


/* ----- search_dept:  find all the matching strings ----- */
RECPTR search_dept (btptrs, wild, rnum, fnum)
	char **btptrs;
	int wild;
	int rnum, fnum;
	{
	RECPTR value;
	int rc, btree, same=0;

	value = new_rec();

	if ((btree = in_btree(btptrs,fnum)) < 0)
		{
		return((RECPTR)0);
		}
	do	{
		if (same = matchflds(btptrs[0], wild, rnum, fnum))
			{
			add_dept(value,dtnum);
			}
		} while(same && btnext(btree) == 0);

	if (rc = closbt(btree))
		{
		fprintf(stderr,"Closbt failed rc = %d\n",rc);
		exit(1);
		}
	return(value);
	}

/* ----- add_dept: add a dept. number to the list ----- */
add_dept(rec, field)
	RECPTR rec;
	int field;
	{
	STUFFPTR node;
	char buf[32];
	int len=0;
	node = new_stuff();

	gfield(field, buf);
	end_it(buf,32);

	if ((len = strlen(buf))>DTNUM_LEN && (field == dtnum))
		buf[DTNUM_LEN] = '\0';

	if (buf[0] != '\0')
		{
		node->info = new_info(len+1);
		strcpy((char *)(node->info),buf);
		node->long_info = node->info;

		if (rec->num <= 0 || rec->head == (STUFFPTR)0)
			{
			rec->head = node;
			rec->tail = node;
			}
		else	{
			rec->tail->_next = node;
			rec->tail = node;
			}
		(rec->num)++;
		}
	}

/* ----- dept_help:  print out the department numbers and names ----- */
dept_help(number)
	int number;
	{
	int rc, btree, fnum;
	char *btptrs[2];

	if (number)
		{
		fnum = dtnum;
		printf("\n\t\tList of Departments by Number\n\n");
		}
	else	{
		fnum = dtname;
		printf("\n\t\tList of Departments by Name\n\n");
		}
	btptrs[0] = (char *)0;
	btptrs[1] = (char *)0;

	if ((btree = in_btree(btptrs,fnum)) < 0)
		{
		return;
		}
	do	{
			add_dname(fnum,Depts);
		} while(btnext(btree) == 0);

	if (rc = closbt(btree))
		{
		fprintf(stderr,"Closbt failed rc = %d\n",rc);
		exit(1);
		}
	}

/* ----- get_dinfo:  add the department information ----- */
STUFFPTR get_dinfo(btptrs)
	char **btptrs;
	{
	STUFFPTR val;
	INFOPTR stuff;
	char buf[LINE_LEN+1], name[32];
	int line=0;
	int rc, btree;

	if (strlen(btptrs[0]) == 0)
		return((STUFFPTR)0);

	stuff = new_info(4*LINE_LEN+2);

	if ((btree = in_btree(btptrs,dtnum)) >=0)
		{
		line++;
		stuff[LINE_LEN*line] = '\n';
						/* add dept name */
		gfield(dtname,name);
		end_it(name, 32);
		sprintf(buf,"Dept of %s", make_name(name));
		(void)insert(stuff,buf,LINE_LEN*line,LINE_LEN*(line+1), 0);
		line++;
		stuff[LINE_LEN*line] = '\n';

		if (rc = closbt(btree))
			{
			fprintf(stderr,"closbt failed rc = %d, btree = %d\n",rc,btree);
			exit(1);
			}
		}
						/* add university name */
	(void)insert(stuff,"University of California, Davis",
		LINE_LEN*line,LINE_LEN*(line+1), 0);
	line++;
	stuff[LINE_LEN*line] = '\n';
						/* add local address info */
	(void)insert(stuff,"Davis, CA 95616",
		LINE_LEN*line,LINE_LEN*(line+1), 0);
	line++;
	stuff[LINE_LEN*line] = '\n';

	stuff[LINE_LEN*line+1] = '\0';

	val = new_stuff();
	val->info = stuff;
	val->long_info = val->info;

	return(val);
	}

/* ----- new_stuff:  create a new node in memory ----- */
STUFFPTR new_stuff()
	{
	STUFFPTR node;

	node = (STUFFPTR) malloc(sizeof(STUFFNODE));

	node->info = (INFOPTR)0;
	node->long_info = (INFOPTR)0;
	node->_next = (STUFFPTR)0;

	return(node);
	}

/* ----- add_dname:  add department name help ----- */
add_dname(fnum, rnum)
	int fnum, rnum;
	{
	char *name, buf[256], num[256];

	gfield(dtnum,num);
	gfield(dtname,buf);

	end_it(num,8);
	end_it(buf,64);

	name = make_name(buf);

	if (fnum == dtnum)
		{
		printf("%s  %s\n",num,name);
		}
	else if (isname(name))  
		{
		printf("%s  %s\n",num,name);
		}
	free(name);
	}

/* ----- isname:  return true if the given string is a name ----- */
int isname(s)
	char *s;
	{
	int i=0, len, val=0;

	if ((len=strlen(s))>1)
		{
		while (i<len && isspace(s[i])) i++;
		if (i<len && isalpha(s[i]))
			val = 1;
		}
	return(val);
	}

