#include <ctype.h>
#include "types.h"
#include "file.h"
#include "main.h"

extern RECPTR find(), find_depts(), dept_find();
extern char *all_upper();
extern dept_help();

char **break_up();
char *malloc();

int DEPT=0;

/* ----- main:  look for the given string and print out the results ----- */
main(argc,argv)
	int argc;
	char **argv;
	{
	char **btptrs;
	char c, d;
	int *wild, i, num;
	RECPTR stuff;

	if (argc != 2)
		{
		printf(USEAGE);
		exit(0);
		}
					/* goto Unify DB directory */
	chdir(PATH);
					/* get argv[1] into needed form */
	btptrs = break_up(argv[1], &num);
	if ((wild = (int *)malloc(num*sizeof(int)+1)) == 0)
		printf("malloc contaminated memory\n");
	for (i=0; i<num; i++)
		{
		wild[i] = wild_card(btptrs[i]);
		btptrs[i] = all_upper(btptrs[i]);
		}
					/* get first two chars of argv[1]*/
	i=0;
	while (isjunk(argv[1][i])) i++;
	c = argv[1][i++];
	while (isjunk(argv[1][i])) i++;
	d = argv[1][i++];
					/* check for help */
	if (need_help(btptrs,wild,num))
		{
		if (c==DEPTCHAR || d==DEPTCHAR)
			{
			if (c==NAMECHAR || d==NAMECHAR)
				dept_help(1);
			else 	dept_help(0);
			}
		else	printf(HELP);
		exit(0);
		}
					/* search for a mailid */
	if (c == HANDLECHAR)
		{
		if ((stuff = find(btptrs,wild,M_mailid)) != (RECPTR)0
			&& stuff->head != (STUFFPTR)0)
			pr_rec(stuff);
		else	{
			printf("The handle, %s, was not found\n",btptrs[0]);
			}
		}
					/* search for a name */
	else if (c == NAMECHAR && d != DEPTCHAR)
		{
		stuff = find(btptrs,wild,M_last);

		if (stuff != (RECPTR)0 && stuff->head != (STUFFPTR)0)
			pr_rec(stuff);
		else	{
			int i=0;

			printf("The name, ");
			while(btptrs[i] != (char *)0)
				printf("%s, ",btptrs[i++]);
			printf("was not found\n");
			}
		}
					/* search for a dept number */
	else if (c == DEPTCHAR && isdigit(btptrs[0][0]))
		{
		RECPTR depts;

		DEPT=1;

		depts = find_depts(btptrs,wild,D_dtnum);

		if (depts->num > 1)
			print_warning(btptrs,depts->num);

		stuff = dept_find(depts, DEPTS);

		if (stuff != (RECPTR)0 && stuff->head != (STUFFPTR)0)
			pr_rec(stuff);
		else	{
			int i=0;

			printf("The department number, ");
			while(btptrs[i] != (char *)0)
				printf("%s, ",btptrs[i++]);
			printf("was not found try \"*help\" for a valid list\n");
			}
		}
						/* search for a dept name */
	else if (c==DEPTCHAR && isalpha(btptrs[0][0]))
		{
		RECPTR depts;

		DEPT=1;

		depts = find_depts(btptrs,wild,D_dtname);

		if (depts->num > 1)
			print_warning(btptrs,depts->num);

		stuff = dept_find(depts, DEPTS);

		if (stuff != (RECPTR)0 && stuff->head != (STUFFPTR)0)
			pr_rec(stuff);
		else	{
			int i=0;

			printf("The department name, ");
			while(btptrs[i] != (char *)0)
				printf("%s, ",btptrs[i++]);
			printf("was not found try \"*help\" for a valid list\n");
			}
		}
	else if (isalpha(c) || isdigit(c)) {
						/* search all fields in Mail */
		if(btptrs[1] == (char *)0)
			{
			stuff = find(btptrs,wild,M_all);
			}
						/* search first and last name */
		else	{
			stuff = find(btptrs,wild,M_last);
			}

		if (stuff != (RECPTR)0 && stuff->head != (STUFFPTR)0)
			pr_rec(stuff);
		else	{
			int i=0;

			printf("no match for ");
			while(btptrs[i] != (char *)0)
				printf("%s ",btptrs[i++]);
			printf("\n");
			}
		}
	else	{
		printf(USEAGE);
		}
	exit(0);
	}

/* ----- pr_rec:  print out the numbers pointed to ----- */
pr_rec(value)
	RECPTR value;
	{
	STUFFPTR ptr = value->head;

	if (value->head->_next != (STUFFPTR)0)
		{
		int i;

		for (i=0; i<value->num; i++)
			{
			printf("%s\n",ptr->info);
			ptr = ptr->_next;
			}
		if (!DEPT)
			printf(MESSAGE);
		}
	else	printf("%s\n",ptr->long_info);
	}


/* ----- wild_card:  return an array of booleans for wild cards ----- */
int wild_card(string)
	char *string;
	{
	int val;
	int count=0, j, done=0;

	j = strlen(string)-1;
	while (j>=0 && !done)
		{
		if (string[j] == WILDCHAR)
			count++;
		else	done=1;
		j--;
		}
	if (count >= 3)
		val = 1;
	else	val = 0;

	return(val);
	}

/* ----- break_up: separate one arg if a comma is used ----- */
char **break_up(s, count)
	char *s;
	int *count;
	{
	char **val, temp[10][32];
	int i=0, j=0, index=0, len;
	
	len = strlen(s);
	while (index<len)
		{
		if (s[index] != SEPCHAR) 
			temp[i][j++] = s[index];
		else	{
			temp[i][j] = '\0';
			j =0;
			i++;
			}
		index++;
		}
	temp[i][j] = '\0';
	i++;

	(*count) = i;

	if ((val = (char **) malloc((i+1)*sizeof(char *)+1)) == 0)
		printf("malloc contaminated memory\n");
	for (i=0; i<(*count); i++)
		{
		if ((val[i] = (char *) malloc(strlen(temp[i])+1)) == 0)
			printf("malloc contaminated memory\n");
		strcpy(val[i], temp[i]);
		}
	val[i] = (char *)0;

	return(val);
	}


/* ----- need_help: return true if looking for help ----- */
int need_help(ptrs, wild, num)
	char **ptrs;
	int *wild, num;
	{
	if (num>1)
		return(0);
	if (wild[0])
		return(0);
	if (strcmp(ptrs[0],"HELP") != 0)
		return(0);
	return(1);
	}

/* ----- isjunk:  return true if spaces or quotes ----- */
int isjunk(c)
	int c;
	{
	if (c==040 || c==011 || c==013 || c==042 || c==047)
		return(1);
	else	return(0);
	}

/* ----- print_warning:  if more than one match, warn user ----- */
print_warning(btptrs,num)
	char **btptrs;
	int num;
	{
	char s[256];
	int i=0;

	s[0] = '\0';
	while (btptrs[i] != (char *)0)
		sprintf(s,"%s %s",s,btptrs[i++]);

	printf("\n\tYour search for %s has found %d departments.\n",s,num);
	printf("\t(Press ^C to stop the listing of information.)\n\n");
	}
