/* ----- RECORD READING ROUTINES FOR DATABASE ----- */

#include <stdio.h>
#include <ctype.h>
#include "/usr/unify/include/fdesc.h"
#include "/usr/unify/include/dbtypes.h"
#include "/usr/unify/include/btincl.h"
#include "file.h"
#include "types.h"

extern char *strallocat(), *make_name();
extern int strcicmp(), same_dept(), *all_lower();
extern int DIRTY, DEPT;

INFOPTR read_info(), read_linfo(), new_info();
char *malloc(), *get_name(), *get_email(), *get_deptname(), *get_one(),
	*get_date(), *get_phone(), **get_alt(); 

/* ----- add_rec: add one entry to the record pointers ----- */
add_rec(value, rnum)
	RECPTR value;
	int rnum;
	{
	STUFFPTR node;
				/* make a new node of information */
	if ((node = (STUFFPTR)malloc(sizeof(STUFFNODE))) == 0)
		printf("malloc contaminated memory\n");
	node->info = read_info(rnum);
	if (!DIRTY)
		{
		DIRTY=1;
		node->long_info = read_linfo(rnum);
		}
	else	node->long_info = (INFOPTR)0;
	node->_next = (STUFFPTR)0;

	(value->num)++;

	if (value->head == (STUFFPTR)0)
		{
		value->head = node;
		value->tail = value->head;
		}
	else	{
		value->tail->_next = node;
		value->tail = node;
		}
	}

/* ----- read_info: read in the short information from the data file ----- */
INFOPTR read_info(rnum)
	int rnum;
	{
	INFOPTR stuff;
	char *info;
	int pos, line=0;

				/* allocate and clear the space */
	stuff = new_info(LINE_LEN*3+4);

				/* add the name and mailid */
	pos = insert(stuff,get_name(rnum),LINE_LEN*line,LINE_LEN*(line+1), 1);
	line++;

				/* get the email or job title for depts' info*/
	if (DEPT)
		{
		if ((info = get_one(mjobtle)) != (char *)0)
			{
			info = make_name(info);
			}
		else	info = (char *)0;
		}
	else	info = get_email(rnum);
				/* add it */
	if ((pos + 3 + strlen(info)) > LINE_LEN*line)
		{
		stuff[LINE_LEN*line-1] = '\n';
		pos = insert(stuff,info,LINE_LEN*line+10,LINE_LEN*(line+1),-1);
		line++;
		}
	else	{
		pos = insert(stuff, info, pos+3, LINE_LEN*line, -1);
		}
				/* add the phone number */
	/*  ---not enough room on one line for more information
	phone = get_one(mphone);
	if ((pos + 5 + (n=strlen(phone))) > LINE_LEN*line && n>=4)
		{
		stuff[LINE_LEN*line-1] = '\n';
		insert(stuff, phone, LINE_LEN*line, LINE_LEN*(line+1), -1);
		line++;
		}
	else	{
		if (n>=4)
			insert(stuff, phone, pos+5, LINE_LEN*line, -1);
		}
	*/
	stuff[LINE_LEN*line+1] = '\0';

	return(stuff);
	}

/* ----- read_linfo:  read the long information for one person ----- */
INFOPTR read_linfo(rnum)
	int rnum;
	{
	INFOPTR stuff;
	int line=0;
	char *name, *email, *phone, *dept, *title, *jtitle, *room, *build, 
		**alt, *update;
	char buf[LINE_LEN]; 

	stuff = new_info(LINE_LEN*NUM_LINES);

	if ((name = get_name(rnum)) != (char *)0)
		{
		(void) insert(stuff, "name:",
			LINE_LEN*line, LINE_LEN*line+MARGIN-1, 1);
		(void) insert(stuff, name, 
			LINE_LEN*line+MARGIN-1, LINE_LEN*(line+1), 1);
		line++;
		}
	if ((jtitle = get_one(mjobtle)) != (char *)0)
		{
		jtitle = make_name(jtitle);
		(void) insert(stuff, "\njob title:",
			LINE_LEN*line, LINE_LEN*line+MARGIN, 1);
		(void) insert(stuff, jtitle, 
			LINE_LEN*line+MARGIN, LINE_LEN*(line+1), 1);
		line++;
		}
	if ((email = get_email(rnum)) != (char *)0)
		{
		(void) insert(stuff, "\nemail address:",
			LINE_LEN*line, LINE_LEN*line+MARGIN, 1);
		(void) insert(stuff, email, 
			LINE_LEN*line+MARGIN, LINE_LEN*(line+1), 1);
		line++;
		}
	if ((phone = get_phone(mphone)) != (char *)0)
		{
		(void) insert(stuff, "\nphone number:",
			LINE_LEN*line, LINE_LEN*line+MARGIN, 1);
		(void) insert(stuff, phone, 
			LINE_LEN*line+MARGIN, LINE_LEN*(line+1), 1);
		line++;
		}
	if ((dept = get_deptname(rnum, get_one(mdept))) != (char *)0)
		{
		(void) insert(stuff, "\ndepartment:",
			LINE_LEN*line, LINE_LEN*line+MARGIN, 1);
		(void) insert(stuff, dept, 
			LINE_LEN*line+MARGIN, LINE_LEN*(line+1), 1);
		line++;
		}
	if ((title = get_one(mtitle)) != (char *)0)
		{
		title = make_name(title);
		(void) insert(stuff, "\ntitle:",
			LINE_LEN*line, LINE_LEN*line+MARGIN, 1);
		(void) insert(stuff, title, 
			LINE_LEN*line+MARGIN, LINE_LEN*(line+1), 1);
		line++;
		}
	room = get_one(mroom);  build = get_one(mbldg);
	if ((strlen(room)+strlen(build)) > 0)
		{
		build = make_name(build);
		sprintf(buf,"%s %s",room, build);
		(void) insert(stuff, "\noffice:",
			LINE_LEN*line, LINE_LEN*line+MARGIN, 1);
		(void) insert(stuff, buf, 
			LINE_LEN*line+MARGIN, LINE_LEN*(line+1), 1);
		line++;
		}
	if ((alt = get_alt(rnum)) != (char **)0)
		{
		if (alt[0] != (char *)0 && !same_dept(dept,alt[0]))
			{
			(void) insert(stuff, "\nalt. dept:",
				LINE_LEN*line, LINE_LEN*line+MARGIN, 1);
			(void) insert(stuff, alt[0], 
				LINE_LEN*line+MARGIN, LINE_LEN*(line+1), 1);
			line++;
			}
		if (alt[1] != (char *)0 && !same_dept(title, alt[1]))
			{
			(void) insert(stuff, "\nalt. title:",
				LINE_LEN*line, LINE_LEN*line+MARGIN, 1);
			(void) insert(stuff, alt[1], 
				LINE_LEN*line+MARGIN, LINE_LEN*(line+1), 1);
			line++;
			}
		if (alt[2] != (char *)0 && strcmp(phone,alt[2]) != 0)
			{
			(void) insert(stuff, "\nalt. phone:",
				LINE_LEN*line, LINE_LEN*line+MARGIN, 1);
			(void) insert(stuff, alt[2], 
				LINE_LEN*line+MARGIN, LINE_LEN*(line+1), 1);
			line++;
			}
		}

	if ((update = get_date(mupdate)) != (char *)0)
		{
		(void) insert(stuff, "\nlast updated:",
			LINE_LEN*line, LINE_LEN*line+MARGIN, 1);
		(void) insert(stuff, update, 
			LINE_LEN*line+MARGIN, LINE_LEN*(line+1), 1);
		line++;
		}

	stuff[LINE_LEN*line] = '\0';

	return(stuff);
	}

/* ----- new_info: allocate and clear a space for new info string ----- */
INFOPTR new_info(size)
	int size;
	{
	INFOPTR s;
	int i;

	if ((s = (INFOPTR) malloc(size+1)) == 0)
		printf("malloc contaminated memory\n");

	for (i=0; i<size; i++)
		s[i] = ' ';

	s[size] = '\0';

	return(s);
	}

/* ----- get_name:  retrive the person't name from database ----- */
char *get_name(rnum)
	int rnum;
	{
	char buffer[32], *val;

/*
printf("starting get name\n");
*/
	if ((val = malloc(sizeof(char)*NAME_LEN+1)) == 0)
		printf("malloc contaminated memory\n");

	switch (rnum)
	{
	case Mailid:
		{
		gfield(mlstname,buffer);
		sprintf(val,"%s,",make_name(buffer));
		gfield(mfstname,buffer);
		sprintf(val,"%s %s",val, make_name(buffer));
		gfield(mmidname,buffer);
		sprintf(val,"%s %s", val, make_name(buffer));
		gfield(mailid,buffer);
		end_it(buffer, 32);
		sprintf(val,"%s (%s)",val, buffer);
		}
		break;
	case Noid:
		{
		gfield(nidlast,buffer);
		sprintf(val,"%s,",make_name(buffer));
		gfield(nidfirst,buffer);
		sprintf(val,"%s %s (none)",val, make_name(buffer));
		}
		break;
	case Directry:
		{
		gfield(Dlstname,buffer);
		sprintf(val,"%s,",make_name(buffer));
		gfield(Dfstname,buffer);
		sprintf(val,"%s %s",val, make_name(buffer));
		gfield(Dmidname,buffer);
		sprintf(val,"%s %s", val, make_name(buffer));
		}
		break;
	default:
		printf("internal error.  bad record to get_name()\n");
	}
/*
printf("ending get name\n");
*/
	return(val);
	}

/* ----- get_email:  get the email address if there is one ----- */
char *get_email(rnum)
	int rnum;
	{
	char *email;
	struct fdesc f;
	/*
	int unify_sucks;
	*/

	if (fldesc(mailid,&f) == 0)
		{
		return((char *)0);
		}
	if (f.f_rec != rnum)
		{
		return((char *)0);
		}
	email = (char *)0;

	if (rnum == Mailid)
		{
		char buf[32];

		if ((email = (char *)malloc(LINE_LEN+1)) == 0)
			printf("malloc contaminated memory\n");

		/* --------- Russ wants mailid's only
		gfield(mcomputr,machine);
		end_it(machine, 32);

		if (valid(machine))
			{
			gfield(muserid, userid);
			end_it(userid, 32);
			sprintf(email,"%s@%s.%s",userid,machine, DOMAIN);
			}
		*/
		gfield(mailid, buf);
		end_it(buf,32);
		all_lower(buf);
		sprintf(email,"%s@%s", buf, DOMAIN);
		}
/*
printf("ending get email\n");
*/
	return(email);
	}


/* ----- get_deptname: given the number, retrieve the name ----- */
char *get_deptname(rnum, number)
	int rnum;
	char *number;
	{
	int rc, btree, len;
	char *val, *btptrs[2], buf[64];
	long old;

	if ((len = strlen(number)) == 0)
		return((char *)0);
	if (len>DTNUM_LEN)
		number[DTNUM_LEN] = '\0';

	loc(rnum, &old);

	btptrs[0] = number;
	btptrs[1] = (char *)0;

	if ((btree = in_btree(btptrs,dtnum)) >=0)
		{
		gfield(dtname, buf);
		val = make_name(buf);

/*
printf("closing btree %d after one search\n",btree);
*/
		if (rc = closbt(btree))
			{
			fprintf(stderr,"closbt failed rc = %d, btree = %d\n",rc,btree);
			exit(1);
			}
		}
	else 	{
		if ((val = (char *) malloc(strlen(number)+1)) == 0)
			printf("malloc contaminated memory\n");
		strcpy(val, number);
		}
/*
printf("after searching, btree = %d, looking for %s\n", btree, btptrs[0]);
*/

	setloc(rnum,old);

/*
printf("end get dept name\n");
*/
	return(val);
	}

/* ----- get_one:  return the value from one field ----- */
char *get_one(field)
	int field;
	{
	char buf[256], *val;
	int len;
	long i;
	struct fdesc f;

	fldesc(field,&f);
	loc(f.f_rec, &i);

	if (i == 0L)
		{
		return((char *)0);
		}
	gfield(field, buf);
	end_it(buf, 256);

	if ((val = (char *) malloc((len = strlen(buf))+1)) == 0)
		printf("malloc contaminated memory\n");
	strcpy(val, buf);

	if (len == 0)
		{
		return((char *)0);
		}

	return(val);
	}


/* ----- get_alt:  get alternate dept, title, and phone ----- */
char **get_alt(rnum)
	int rnum;
	{
	int rc, btree;
	char first[32], last[32], buf[64], **val;
	char *btptrs[3];
	long old;

	loc(rnum, &old);

	gfield(mlstname, last);
	end_it(last, 32);
	gfield(mfstname, first);
	end_it(first, 32);
	btptrs[0] = last;
	btptrs[1] = first;
	btptrs[2] = (char *)0;

	if ((btree = in_btree(btptrs, Dlstname)) >= 0)
		{
						/* close btree */
		if ((rc = closbt(btree)) < 0 )
			{
			fprintf(stderr,
			  "btclose failed rc= %d, btree= %d\n",rc,btree);
			exit(1);
			}
						/* double check found one */
		gfield(Dfstname, buf);
		end_it(buf,64);
		if (strcmp(first, buf) != 0)
			{
			return((char **)0);
			}
		if ((val = (char **) malloc(sizeof(char *)*4)) == 0)
			printf("malloc contaminated memory\n");
		val[0] = get_deptname(Directry, get_one(Ddept));
		if (strlen(val[0]) > 0)
			val[0] = make_name(val[0]);
		val[1] = get_one(Dtitle);
		if (strlen(val[1]) > 0)
			val[1] = make_name(val[1]);
		val[2] = get_phone(Dphone);
		val[3] = (char *)0;
		}
	else 	{
		if ((val = (char **) malloc(sizeof(char **))) == 0)
			printf("malloc contaminated memory\n");
		val = (char **)0;
		}

	setloc(rnum,old);
/*
printf("end get alt\n");
*/

	return(val);
	}

/* ----- get_phone: return the phone number ----- */
char *get_phone(fieldnum)
	int fieldnum;
	{
	char *phone, *temp, buf[LINE_LEN];
	int i=0, j=0, len;

	temp = get_one(fieldnum);

	if ((len = strlen(temp)) == 0)
		return((char *)0);
					/* make a whole phone number */
	while (i<len)
		{
		if (temp[i]=='2' && !(i>=2 && temp[i-1]=='5') && (i+5<len) && 
			temp[i+1]=='-')
			{
			sprintf(buf,"%s(916) 75",buf);
			j= strlen(buf);
			}
		while (i<len && (isdigit(temp[i]) || temp[i] == '-'))
			buf[j++] = temp[i++];
		while (i<len && !(isdigit(temp[i]) || temp[i] == '-'))
			buf[j++] = temp[i++];
		}
	buf[j] = '\0';
	if ((phone = (char *)malloc(strlen(buf)+1)) == 0)
		printf("malloc contaminated memory\n");
	sprintf(phone,"%s",buf);

	return(phone);
	}


/* ----- get_date:  convert binary rep into a string ----- */
char *get_date(field)
	int field;
	{
	short buf;
	char *val;

	val = malloc(sizeof(char)*10);

	gfield(field,&buf);
	dspdt(buf,val);

	val[8] = '\0';

	return(val);
	}
