/* ----- TYPE DEFINITIONS ----- */

typedef char *INFOPTR, INFONODE;

typedef struct stuff
	{
	INFOPTR info;
	INFOPTR long_info;
	struct stuff *_next;
	} STUFFNODE, *STUFFPTR;

typedef struct records
	{
	int num;
	STUFFPTR head, tail;
	} RECNODE, *RECPTR;

typedef int PACKET[7][2];


/* ----- GLOBAL DEFINES ----- */

#define USEAGE "\n\
useage:  [string | .name | !mailid | pattern... | last,first | \n\
         \"*[department name | department number]\" | help]\n"
#define PATH "/Unify/bin"
#define DOMAIN "ucdavis.edu"
#define LINE_LEN 70
#define NAME_LEN 35
#define DTNUM_LEN 6
#define NUM_LINES 12
#define MARGIN 20
#define DEPTCHAR '*'
#define NAMECHAR '.'
#define HANDLECHAR '!'
#define WILDCHAR '.'
#define SEPCHAR ','
#define MESSAGE "\n\
       To see one record in long format, look it up with \"\!xxx\",\n \
  where \"xxx\" is the handle shown in parenthesis following the name.\n"
#define HELP "\n\
There are several ways to look someone up in the ucdavis whois database.\n\n\
1) Search for a string like \"Rose\" or \"BKMartin\" which will look for a\n\
   mail I.D., first name, last name or nickname.\n\
2) Search for a last name with \".name\" or the full name with \"last,first\".\n\
3) List all members of a given department using the number, \"*301001\" or the \n\
   name, \"\'*ag economics\'\".  If there is a space in the name, enclose \n\
   the query within quotes.  To see a listing of all the departments,\n\
   type \"*help\".  The help information is very long.\n\
4) Search for a pattern may be combined with any of the above options.  Just\n\
   end the first part of the string with three dots like \"lem...\", \n\
   \"grwhiteh...\", \"\'*ag econ...\'\", or \"mcca...,sam...\".\n\n\
The case of the letters does not matter.\n\n\
If the search finds two or more entries, the following information will be\n\
printed for each entry:  name, mail I.D., electronic mail address.\n\
If a unique entry is found, then more detailed information will be printed:\n\
name, mail I.D., job title, phone number, email address, office location,\n\
department, title, alternate department, title, and phone.\n\n\
The complete mailing address for the UC Davis campus is:\n\
               Name of Person\n\
                U. C. Davis\n\
             Department of Person\n\
               Davis, CA  95616\n"
